using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using CD67.FicheCollege.Entity;
using CD67.FicheCollege.Factory;

namespace CD67.FicheCollege.MVC.Controllers
{
    public class TerritoireController : Controller
    {
        private Entities db = new Entities();

        // GET: Territoire
        public ActionResult Index()
        {
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            return View(territoireFactory.getAll());
        }

        // GET: Territoire/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id.Value);
            if (territoire == null)
            {
                return HttpNotFound();
            }
            return View(territoire);
        }

        // GET: Territoire/Create
        public ActionResult Create()
        {
            Entity.Territoire territoire = new Entity.Territoire();
            return View(territoire);
        }

        // POST: Territoire/Create
        // Afin de déjouer les attaques par sur-validation, activez les propriétés spécifiques que vous voulez lier. Pour 
        // plus de détails, voir  http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Territoire territoire)
        {
            if (ModelState.IsValid)
            {
                TerritoireFactory territoireFactory = new TerritoireFactory(db);
                territoireFactory.add(ref territoire);
                return RedirectToAction("Index");
            }

            return View(territoire);
        }

        // GET: Territoire/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id.Value);
            if (territoire == null)
            {
                return HttpNotFound();
            }
            return View(territoire);
        }

        // POST: Territoire/Edit/5
        // Afin de déjouer les attaques par sur-validation, activez les propriétés spécifiques que vous voulez lier. Pour 
        // plus de détails, voir  http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(Territoire territoire)
        {
            if (ModelState.IsValid)
            {
                TerritoireFactory territoireFactory = new TerritoireFactory(db);
                territoireFactory.update(ref territoire);
                return RedirectToAction("Index");
            }
            return View(territoire);
        }

        // GET: Territoire/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id.Value);
            if (territoire == null)
            {
                return HttpNotFound();
            }
            return View(territoire);
        }

        // POST: Territoire/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id);
            territoireFactory.delete(ref territoire);
            return RedirectToAction("Index");
        }

        public ActionResult Up(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id.Value);
            territoireFactory.Up(ref territoire);
            return RedirectToAction("Index");
        }

        public ActionResult Down(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TerritoireFactory territoireFactory = new TerritoireFactory(db);
            Entity.Territoire territoire = territoireFactory.getById(id.Value);
            territoireFactory.Down(ref territoire);
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
